Description

It would be nice if Hash had a way to create a sub-hash with a limited set of keys. This would be useful for keyword functions in
particular, because sometimes you have a large hash of things and you only want to send a subset to another function.

A definition somewhat like:

class Hash
def & (keys)
keys.each_with_object (self.class.new) {|key, hash| hash[key] = selflkey] if has_key? (key)}
end
end

You can see some similar definitions here:
https://github.com/rails/rails/blob/b670fadb978c8a12c3414ed842cd49e4fde2cecO/activesupport/lib/active_support/core_ext/hash/slic
e.rb#l21

It might be nice to support slice and slice! in a similar logical sense to Array rather than proposed & operator above - that would just
be nice shortcut.

Related issues:
Related to Ruby trunk - Feature #8499: Importing Hash#slice, Hash#slice!, Has... Closed

History

#1 - 06/06/2016 03:54 AM - ioquatix (Samuel Williams)

Just to add to this, | also found an implementation here:

https://github.com/rubyworks/facets/blob/master/lib/core/facets/hash/slice.rb

Now | wonder if this warrants being in the standard library. | believe it probably does since it appears lots of people are using it, and it would probably
be significantly faster written in C.

#2 - 07/19/2016 07:46 AM - shyouhei (Shyouhei Urabe)
- Related to Feature #8499: Importing Hash#slice, Hash#slice!, Hash#except, and Hash#except! from ActiveSupport added

#3 - 07/19/2016 07:50 AM - matz (Yukihiro Matsumoto)
- Status changed from Open to Closed

| am against having Hash#&. Array#& takes two arrays. The proposed Hash#& takes a hash and key array.
if you want Hash#slice to be added to the core, submit a new issue. But note that now we have real
keyword arguments so that we have less need for manipulating keyword hashes explicitly.

Matz.

#4 - 08/04/2016 07:55 AM - usa (Usaku NAKAMURA)
- Status changed from Closed to Rejected

- Tracker changed from Bug to Feature
